Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/1687.html

1687. Delivering Boxes from Storage to Ports

Level

Hard

Description

You have the task of delivering some boxes from storage to their ports using only one ship. However, this ship has a limit on the number of boxes and the total weight that it can carry.

You are given an array boxes, where boxes[i] = [ports_i, weight_i], and three integers portsCount, maxBoxes, and maxWeight.

  • ports_i is the port where you need to deliver the i-th box and weights_i is the weight of the i-th box.
  • portsCount is the number of ports.
  • maxBoxes and maxWeight are the respective box and weight limits of the ship.

The boxes need to be delivered in the order they are given. The ship will follow these steps:

  • The ship will take some number of boxes from the boxes queue, not violating the maxBoxes and maxWeight constraints.
  • For each loaded box in order, the ship will make a trip to the port the box needs to be delivered to and deliver it. If the ship is already at the correct port, no trip is needed, and the box can immediately be delivered.
  • The ship then makes a return trip to storage to take more boxes from the queue.

The ship must end at storage after all the boxes have been delivered.

Return the minimum number of trips the ship needs to make to deliver all boxes to their respective ports.

Example 1:

Input: boxes = [[1,1],[2,1],[1,1]], portsCount = 2, maxBoxes = 3, maxWeight = 3

Output: 4

Explanation: The optimal strategy is as follows:

  • The ship takes all the boxes in the queue, goes to port 1, then port 2, then port 1 again, then returns to storage. 4 trips.

So the total number of trips is 4.

Note that the first and third boxes cannot be delivered together because the boxes need to be delivered in order (i.e. the second box needs to be delivered at port 2 before the third box).

Example 2:

Input: boxes = [[1,2],[3,3],[3,1],[3,1],[2,4]], portsCount = 3, maxBoxes = 3, maxWeight = 6

Output: 6

Explanation: The optimal strategy is as follows:

  • The ship takes the first box, goes to port 1, then returns to storage. 2 trips.
  • The ship takes the second, third and fourth boxes, goes to port 3, then returns to storage. 2 trips.
  • The ship takes the fifth box, goes to port 3, then returns to storage. 2 trips.

So the total number of trips is 2 + 2 + 2 = 6.

Example 3:

Input: boxes = [[1,4],[1,2],[2,1],[2,1],[3,2],[3,4]], portsCount = 3, maxBoxes = 6, maxWeight = 7

Output: 6

Explanation: The optimal strategy is as follows:

  • The ship takes the first and second boxes, goes to port 1, then returns to storage. 2 trips.
  • The ship takes the third and fourth boxes, goes to port 2, then returns to storage. 2 trips.
  • The ship takes the fifth and sixth boxes, goes to port 3, then returns to storage. 2 trips.

So the total number of trips is 2 + 2 + 2 = 6.

Example 4:

Input: boxes = [[2,4],[2,5],[3,1],[3,2],[3,7],[3,1],[4,4],[1,3],[5,2]], portsCount = 5, maxBoxes = 5, maxWeight = 7

Output: 14

Explanation: The optimal strategy is as follows:

  • The ship takes the first box, goes to port 2, then storage. 2 trips.
  • The ship takes the second box, goes to port 2, then storage. 2 trips.
  • The ship takes the third and fourth boxes, goes to port 3, then storage. 2 trips.
  • The ship takes the fifth box, goes to port 3, then storage. 2 trips.
  • The ship takes the sixth and seventh boxes, goes to port 3, then port 4, then storage. 3 trips.
  • The ship takes the eighth and ninth boxes, goes to port 1, then port 5, then storage. 3 trips.

So the total number of trips is 2 + 2 + 2 + 2 + 3 + 3 = 14.

Constraints:

  • 1 <= boxes.length <= 10^5
  • 1 <= portsCount, maxBoxes, maxWeight <= 10^5
  • 1 <= ports_i <= portsCount
  • 1 <= weights_i <= maxWeight

Solution

Use dynamic programming with monotonic deque. Let n be the number of boxes. Create an array dp of length n + 1, where dp[i] represents the minimum number of trips to deliver the first i boxes. Also create an array differences of length n + 1, where differences[i] represents the number of different adjacent pairs of ports before index i. Then there is dp[i] = min{dp[j] + differences[i] - differences[j + 1] + 2} such that i - j <= maxBoxes and the sum of weights from index j + 1 to index i is less than or equal to maxWeight. Finally, return dp[n].

  • class Solution {
        public int boxDelivering(int[][] boxes, int portsCount, int maxBoxes, int maxWeight) {
            int length = boxes.length;
            int[] ports = new int[length + 1];
            int[] weights = new int[length + 1];
            int[] differences = new int[length + 1];
            long[] prefixWeights = new long[length + 1];
            for (int i = 1; i <= length; i++) {
                ports[i] = boxes[i - 1][0];
                weights[i] = boxes[i - 1][1];
                if (i > 1)
                    differences[i] = differences[i - 1] + (ports[i - 1] != ports[i] ? 1 : 0);
                prefixWeights[i] = prefixWeights[i - 1] + weights[i];
            }
            Deque<Integer> deque = new LinkedList<Integer>();
            deque.offerLast(0);
            int[] dp = new int[length + 1];
            int[] remain = new int[length + 1];
            for (int i = 1; i <= length; i++) {
                while (!deque.isEmpty() && (i - deque.peekFirst() > maxBoxes || prefixWeights[i] - prefixWeights[deque.peekFirst()] > maxWeight))
                    deque.pollFirst();
                dp[i] = remain[deque.peekFirst()] + differences[i] + 2;
                if (i != length) {
                    remain[i] = dp[i] - differences[i + 1];
                    while (!deque.isEmpty() && remain[i] <= remain[deque.peekLast()])
                        deque.pollLast();
                    deque.offerLast(i);
                }
            }
            return dp[length];
        }
    }
    
    ############
    
    class Solution {
        public int boxDelivering(int[][] boxes, int portsCount, int maxBoxes, int maxWeight) {
            int n = boxes.length;
            long[] ws = new long[n + 1];
            int[] cs = new int[n];
            for (int i = 0; i < n; ++i) {
                int p = boxes[i][0], w = boxes[i][1];
                ws[i + 1] = ws[i] + w;
                if (i < n - 1) {
                    cs[i + 1] = cs[i] + (p != boxes[i + 1][0] ? 1 : 0);
                }
            }
            int[] f = new int[n + 1];
            Deque<Integer> q = new ArrayDeque<>();
            q.offer(0);
            for (int i = 1; i <= n; ++i) {
                while (!q.isEmpty()
                    && (i - q.peekFirst() > maxBoxes || ws[i] - ws[q.peekFirst()] > maxWeight)) {
                    q.pollFirst();
                }
                if (!q.isEmpty()) {
                    f[i] = cs[i - 1] + f[q.peekFirst()] - cs[q.peekFirst()] + 2;
                }
                if (i < n) {
                    while (!q.isEmpty() && f[q.peekLast()] - cs[q.peekLast()] >= f[i] - cs[i]) {
                        q.pollLast();
                    }
                    q.offer(i);
                }
            }
            return f[n];
        }
    }
    
  • class Solution:
        def boxDelivering(
            self, boxes: List[List[int]], portsCount: int, maxBoxes: int, maxWeight: int
        ) -> int:
            n = len(boxes)
            ws = list(accumulate((box[1] for box in boxes), initial=0))
            c = [int(a != b) for a, b in pairwise(box[0] for box in boxes)]
            cs = list(accumulate(c, initial=0))
            f = [0] * (n + 1)
            q = deque([0])
            for i in range(1, n + 1):
                while q and (i - q[0] > maxBoxes or ws[i] - ws[q[0]] > maxWeight):
                    q.popleft()
                if q:
                    f[i] = cs[i - 1] + f[q[0]] - cs[q[0]] + 2
                if i < n:
                    while q and f[q[-1]] - cs[q[-1]] >= f[i] - cs[i]:
                        q.pop()
                    q.append(i)
            return f[n]
    
    
    
  • class Solution {
    public:
        int boxDelivering(vector<vector<int>>& boxes, int portsCount, int maxBoxes, int maxWeight) {
            int n = boxes.size();
            long ws[n + 1];
            int f[n + 1];
            int cs[n];
            ws[0] = cs[0] = f[0] = 0;
            for (int i = 0; i < n; ++i) {
                int p = boxes[i][0], w = boxes[i][1];
                ws[i + 1] = ws[i] + w;
                if (i < n - 1) cs[i + 1] = cs[i] + (p != boxes[i + 1][0]);
            }
            deque<int> q{ {0} };
            for (int i = 1; i <= n; ++i) {
                while (!q.empty() && (i - q.front() > maxBoxes || ws[i] - ws[q.front()] > maxWeight)) q.pop_front();
                if (!q.empty()) f[i] = cs[i - 1] + f[q.front()] - cs[q.front()] + 2;
                if (i < n) {
                    while (!q.empty() && f[q.back()] - cs[q.back()] >= f[i] - cs[i]) q.pop_back();
                    q.push_back(i);
                }
            }
            return f[n];
        }
    };
    
  • func boxDelivering(boxes [][]int, portsCount int, maxBoxes int, maxWeight int) int {
    	n := len(boxes)
    	ws := make([]int, n+1)
    	cs := make([]int, n)
    	for i, box := range boxes {
    		p, w := box[0], box[1]
    		ws[i+1] = ws[i] + w
    		if i < n-1 {
    			t := 0
    			if p != boxes[i+1][0] {
    				t++
    			}
    			cs[i+1] = cs[i] + t
    		}
    	}
    	f := make([]int, n+1)
    	q := []int{0}
    	for i := 1; i <= n; i++ {
    		for len(q) > 0 && (i-q[0] > maxBoxes || ws[i]-ws[q[0]] > maxWeight) {
    			q = q[1:]
    		}
    		if len(q) > 0 {
    			f[i] = cs[i-1] + f[q[0]] - cs[q[0]] + 2
    		}
    		if i < n {
    			for len(q) > 0 && f[q[len(q)-1]]-cs[q[len(q)-1]] >= f[i]-cs[i] {
    				q = q[:len(q)-1]
    			}
    			q = append(q, i)
    		}
    	}
    	return f[n]
    }
    

All Problems

All Solutions